

from numpy import array, arange, zeros, ones, sqrt, sin, diagonal, trace, argmax, argmin, identity, dot, inner,outer

a = array([[2.0, -1.0],[-1.0, 3.0]])            #array: command to create matrix and array
print(a)

b = array([[2, -1, 5],[-1, 3, 4], [1, 8, 2]],float)
print(b)


print(arange(2,10,2))       # arange(from,to,increment) creates sequential arrays in the specified range

print(arange(2.0,10.0,2.0))

print(zeros(3))             # [axa] Zero matrix generation command in specified dimensions

print(zeros((3),int))

a = zeros((3,3),int)
print(a)


print(ones((2,2)))          # [axa] The command to create a one-to-one matrix with the specified dimensions

a[0] = [2,3,2]              # Change a row
a[1,1] = 5                  # Change an element
a[2,0:2] = [8,-3]           # Change part of a row
print(a)

#Operations on Arrays
a = array([0.0, 4.0, 9.0, 16.0])
print(a/16.0)

print(a - 4.0)

a = array([1.0, 4.0, 9.0, 16.0])
print(sqrt(a))

print(sin(a))

a = array([1.0, 4.0, 9.0, 16.0])
print(sqrt(a[1]))


#Array Functions
A = array([[4,-2,1],[-2,4,-2],[1,-2,3]],float)
b = array([1,4,3],float)
print(diagonal(A))              # Principal diagonal

print(diagonal(A,1))            # First subdiagonal

print(trace(A))                 # Sum of diagonal elements

print(argmax(b))                # Index of largest element

print(argmin(A,axis=0))         # Indices of smallest col. elements

print(identity(3))              # Identity matrix



# There are three functions in numpy that compute array products.


x = array([7,3])
y = array([2,1])
A = array([[1,2],[3,2]])
B = array([[1,1],[2,2]])

# Dot product
print("dot(x,y) =\n",dot(x,y))      # {x}.{y}
print("dot(A,x) =\n",dot(A,x))      # [A]{x}
print("dot(A,B) =\n",dot(A,B))      # [A][B]

# Inner product
print("inner(x,y) =\n",inner(x,y))      # {x}.{y}
print("inner(A,x) =\n",inner(A,x))      # [A]{x}
print("inner(A,B) =\n",inner(A,B))      # [A][B_transpose]

# Outer product
print("outer(x,y) =\n",outer(x,y))
print("outer(A,x) =\n",outer(A,x))
print("outer(A,B) =\n",outer(A,B))

